<script lang="ts">
import {
  composePaths,
  type ControlElement,
  createDefaultValue,
  isObjectArrayControl,
  isPrimitiveArrayControl,
  type JsonFormsRendererRegistryEntry,
  type JsonSchema,
  or,
  rankWith,
  Resolve,
} from "@jsonforms/core";
import {
  // DispatchCell,
  DispatchRenderer,
  rendererProps,
  type RendererProps,
  useJsonFormsArrayControl,
} from "@jsonforms/vue";
import {
  useVuetifyArrayControl,
  ValidationIcon,
} from "@jsonforms/vue-vuetify";
import startCase from "lodash/startCase";
import { defineComponent } from "vue";
import {
  VBtn,
  VCard,
  VCardText,
  VCardTitle,
  // VCol,
  VContainer,
  VIcon,
  VRow,
  // VAvatar,
  VSpacer,
  VTable,
  VToolbar,
  // VToolbarTitle,
  VTooltip,
} from "vuetify/components";

const controlRenderer = defineComponent({
  name: "ArrayControlRenderer",
  components: {
    // DispatchCell,
    DispatchRenderer,
    VCard,
    VCardTitle,
    VCardText,
    // VAvatar,
    VRow,
    // VCol,
    VToolbar,
    // VToolbarTitle,
    VTooltip,
    VIcon,
    VBtn,
    VSpacer,
    VContainer,
    ValidationIcon,
    // ValidationBadge,
    VTable,
  },
  props: {
    ...rendererProps<ControlElement>(),
  },
  setup(props: RendererProps<ControlElement>) {
    return useVuetifyArrayControl(useJsonFormsArrayControl(props));
  },
  computed: {
    arraySchema(): JsonSchema | undefined {
      return Resolve.schema(
        this.control.rootSchema,
        this.control.uischema.scope,
        this.control.rootSchema,
      );
    },
    dataLength(): number {
      return this.control.data ? this.control.data.length : 0;
    },
  },
  methods: {
    composePaths,
    createDefaultValue,
    addButtonClick() {
      this.addItem(
        this.control.path,
        createDefaultValue(this.control.schema, this.control.rootSchema),
      )();
    },
    moveUpClick(event: Event, toMove: number): void {
      event.stopPropagation();
      this.moveUp?.(this.control.path, toMove)();
    },
    moveDownClick(event: Event, toMove: number): void {
      event.stopPropagation();
      this.moveDown?.(this.control.path, toMove)();
    },
    removeItemsClick(event: Event, toDelete: number[]): void {
      event.stopPropagation();
      this.removeItems?.(this.control.path, toDelete)();
    },
    getValidColumnProps(scopedSchema: JsonSchema) {
      if (scopedSchema.type === "object" && typeof scopedSchema.properties === "object") {
        return Object.keys(scopedSchema.properties).filter(
          prop => scopedSchema.properties![prop].type !== "array",
        );
      }
      // primitives
      return [""];
    },
    title(prop: string) {
      return this.control.schema.properties?.[prop]?.title || startCase(prop);
    },
    resolveUiSchema(propName: string) {
      return this.control.schema.properties
        ? this.controlWithoutLabel(`#/properties/${propName}`)
        : this.controlWithoutLabel("#");
    },
    controlWithoutLabel(scope: string): ControlElement {
      return { type: "Control", scope: scope, label: false };
    },
  },
});

export default controlRenderer;

export const entry: JsonFormsRendererRegistryEntry = {
  renderer: controlRenderer,
  tester: rankWith(3, or(isObjectArrayControl, isPrimitiveArrayControl)),
};
</script>

<template>
  <VCard
    v-if="control.visible"
    :class="styles.arrayList.root"
    elevation="0"
  >
    <VCardTitle>
      <VToolbar flat color="rgba(255, 0, 0, 0)">
        <ValidationIcon v-if="control.childErrors.length > 0" :errors="control.childErrors" />
        <VSpacer />

        <VTooltip bottom>
          <template v-slot:activator="{ props }">
            <VBtn
              fab
              text
              elevation="0"
              small
              :aria-label="`Add to ${control.label}`"
              v-bind="props"
              :class="styles.arrayList.addButton"
              :disabled="
                !control.enabled
                  || (appliedOptions.restrict
                    && arraySchema !== undefined
                    && arraySchema.maxItems !== undefined
                    && dataLength >= arraySchema.maxItems)
              "
              @click="addButtonClick"
            >
              <VIcon>mdi-plus</VIcon>
            </VBtn>
          </template>
          {{ `Add to ${control.label}` }}
        </VTooltip>
      </VToolbar>
    </VCardTitle>
    <VCardText>
      <VContainer justify-space-around align-content-center>
        <VRow justify="center">
          <VTable class="array-container flex">
            <thead v-if="control.schema.type === 'object'">
              <tr>
                <th
                  v-for="(prop, index) in getValidColumnProps(control.schema)"
                  :key="`${control.path}-header-${index}`"
                  scope="col"
                >
                  {{ title(prop) }}
                </th>
                <th
                  v-if="control.enabled"
                  :class="appliedOptions.showSortButtons ? 'fixed-cell' : 'fixed-cell-small'"
                  scope="col"
                />
              </tr>
            </thead>
            <tbody>
              <tr
                v-for="(element, index) in control.data"
                :key="`${control.path}-${index}`"
                :class="styles.arrayList.item"
              >
                <td
                  v-for="propName in getValidColumnProps(control.schema)"
                  :key="composePaths(composePaths(control.path, `${index}`), propName)"
                >
                  <DispatchRenderer
                    :schema="control.schema"
                    :uischema="resolveUiSchema(propName)"
                    :path="composePaths(control.path, `${index}`)"
                    :enabled="control.enabled"
                    :renderers="control.renderers"
                    :cells="control.cells"
                  />
                </td>
                <td
                  v-if="control.enabled"
                  :class="appliedOptions.showSortButtons ? 'fixed-cell' : 'fixed-cell-small'"
                >
                  <VTooltip bottom>
                    <template v-slot:activator="{ props }">
                      <VBtn
                        v-if="appliedOptions.showSortButtons"
                        v-bind="props"
                        fab
                        text
                        elevation="0"
                        small
                        aria-label="Move up"
                        :disabled="index <= 0 || !control.enabled"
                        :class="styles.arrayList.itemMoveUp"
                        @click="moveUpClick($event, index)"
                      >
                        <VIcon class="notranslate">
                          mdi-arrow-up
                        </VIcon>
                      </VBtn>
                    </template>
                    Move Up
                  </VTooltip>
                  <VTooltip bottom>
                    <template v-slot:activator="{ props }">
                      <VBtn
                        v-if="appliedOptions.showSortButtons"
                        v-bind="props"
                        fab
                        text
                        elevation="0"
                        small
                        aria-label="Move down"
                        :disabled="index >= dataLength - 1 || !control.enabled"
                        :class="styles.arrayList.itemMoveDown"
                        @click="moveDownClick($event, index)"
                      >
                        <VIcon class="notranslate">
                          mdi-arrow-down
                        </VIcon>
                      </VBtn>
                    </template>
                    Move Down
                  </VTooltip>
                  <VTooltip bottom>
                    <template v-slot:activator="{ props }">
                      <VBtn
                        v-bind="props"
                        fab
                        text
                        elevation="0"
                        small
                        aria-label="Delete"
                        :class="styles.arrayList.itemDelete"
                        :disabled="
                          !control.enabled
                            || (appliedOptions.restrict
                              && arraySchema !== undefined
                              && arraySchema.minItems !== undefined
                              && dataLength <= arraySchema.minItems)
                        "
                        @click="removeItemsClick($event, [index])"
                      >
                        <VIcon class="notranslate">
                          mdi-delete
                        </VIcon>
                      </VBtn>
                    </template>
                    Delete
                  </VTooltip>
                </td>
              </tr>
            </tbody>
          </VTable>
        </VRow>
      </VContainer>
      <VContainer v-if="dataLength === 0" :class="styles.arrayList.noData">
        No data
      </VContainer>
    </VCardText>
  </VCard>
</template>

<style scoped>
.fixed-cell {
  width: 150px;
  padding-left: 0 !important;
  padding-right: 0 !important;
  text-align: center;
}

.fixed-cell-small {
  width: 50px;
  padding-left: 0 !important;
  padding-right: 0 !important;
  text-align: center;
}

.array-container {
  width: 100%;
}
.array-container tbody tr td {
  border-bottom: none !important;
}

.array-container tbody tr td .container {
  padding: 0;
  margin: 0;
}
</style>
